abstract class Factory {
    public final Product create() {
	return createProduct();
    }
    protected abstract Product createProduct();
}

abstract class Product {
    public abstract String getProduct_name();
}



//---------------------------------
class CameraFactory extends Factory {
    protected Product createProduct(){
	return new Camera();
    }
}

class VideoFactory extends Factory {
    protected Product createProduct() {
	return new Video();
	    }
}
//---------------------------------

//---------------------------------

class Camera extends Product {
    public String getProduct_name() {
	return "Camera";
    }
}

class Video extends Product {
    public String getProduct_name() {
	return "Video";
    }
}
//---------------------------------

class Main {
    public static void main(String[] args) {

	Factory f1 = new CameraFactory();
	Product p1 = f1.create();
	System.out.println(p1.getProduct_name());
    }
} 