interface Strategy {
    int check(int mid_point, int final_point);
}


/*
   mid_point(50%), final_point(50%)
 */
class Strategy1 implements Strategy {
    public int check(int mid_point, int final_point) {
	double point  = (mid_point+final_point)/2.0;
	
	if (point >= 80) {
	    return 2;
	}
	else if (point >=70) {
	    return 1;
	}
	else if (point >= 60) {
	    return 0;
	}
	else {
	    return -1;
	}
    }
}


/*
  max(mid_point, final_point)
*/
class Strategy2 implements Strategy {
    public int check(int mid_point, int final_point) {
	int point  = Math.max(mid_point, final_point);

	if (point >= 80) {
	    return 2;
	}
	else if (point >=70) {
	    return 1;
	}
	else if (point >= 60) {
	    return 0;
	}
	else {
	    return -1;
	}
    }
}

class Evaluator {
    Strategy currentStrategy;
    
    Evaluator(Strategy initialStrategy) {
	this.currentStrategy = initialStrategy;
    }

    void changeStrategy(Strategy newStrategy) {
	this.currentStrategy = newStrategy;
    }

    void getEvaluation(int mid_point, int final_point) {
	//т̕]
	int result = currentStrategy.check(mid_point, final_point);
	
	//A,B,C,D...
	if (result == 2) {
	    System.out.println(":"+mid_point+" :"+final_point+"ŏI: A");
	}
	else if (result == 1) {
	    System.out.println(":"+mid_point+" :"+final_point+"ŏI: B");
	}
	else if (result == 0) {
	    System.out.println(":"+mid_point+" :"+final_point+"ŏI: C");
	}
	else {
	    System.out.println(":"+mid_point+" :"+final_point+"ŏI: D");
	}
    }
}
	
/*
  java Main 20 50
20:mid_point, 50: final_point

 */	

class Main {
    public static void main(String[] args) {
	int mid_point = Integer.parseInt(args[0]);
	int final_point = Integer.parseInt(args[1]);

	System.out.println("Strategy1");
	Evaluator eval1 = new Evaluator(new Strategy1());
	eval1.getEvaluation(mid_point, final_point);

	System.out.println("\n"+"Strategy2");
	eval1.changeStrategy(new Strategy2());
	eval1.getEvaluation(mid_point, final_point);
    }

}